#include <sicstus/sicstus.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

FILE *ptr_fp;

void write_to_file(u_int8_t* input, int len, char *name) {
	if ((ptr_fp = fopen(name, "wb")) == NULL) {
		printf("Unable to open file!\n");
		exit(1);
	}
	if ( fwrite(input, len, 1, ptr_fp) != 1 )
	{
		printf("Write error!\n");
		exit(1);
	}
	fclose(ptr_fp);
}

void read_from_file(char *name, void **address) {
	int fd;
	fd = open(name, O_RDONLY);
	if (fd == -1) {
		printf( "Read error!\n" );
		*address = NULL;
		exit(1);
	} else {
		char* output;
		struct stat buf;
		fstat(fd, &buf);
		int size = buf.st_size;
		output = mmap(0, size, PROT_READ, MAP_SHARED, fd,0);
		*address = output;
	}
	close(fd);
}