#!/bin/bash
cd prolog
mkdir -p testresults
rm -f testresults/*.xml
echo "<testsuite name=\"hudson configuration\" timestamp=\"0\" time=\"0\" hostname=\"hudson\" tests=\"0\" skipped=\"0\" failures=\"0\" errors=\"0\"><properties /><testcase name=\"hudson configuration\" classname=\"Configuration.Hudson\" time=\"0\"></testcase><system-out /><system-err /></testsuite>" > testresults/hudson.xml

export PROB_JUNIT_DIR="testresults"
export PROB_JUNIT=" -junit $PROB_JUNIT_DIR"

# set parallel to a default value
if [ -z "$PARALLEL" ]
then
   PARALLEL=1
fi

echo "Generating Makefile: Makefile_All_Tests"
sicstus -l src/test_runner.pl --goal "generate_makefile_all_tests, halt."

echo "Running Makefile: Makefile_All_Tests"
# sanity checking test cases: multiple ids, missing output files, etc.
make sanity_check && make -f Makefile_All_Tests -j $PARALLEL -k
