#ifndef MWORK_H_INCLUDED
#define MWORK_H_INCLUDED

#include <zmq.h>
#include <czmq.h>

#include "mstats.h"
#include "../common/queue.h"

struct msend_work_args {
    mStats *stats;
    struct id_map *ips;
    wQueue *q;
    int fd_logfile;
};

int has_empty_worker(mStats const * const stats);

int work_sender(zloop_t * const loop,
                const int timer_id,
                mStats * const stats,
                struct id_map const * const ips,
                wQueue * const q,
                int fd_logfile);

int send_work_timer_fn(zloop_t *loop, int timer_id, void *args);

int work_sender_no_loop(mStats * const stats,
                        struct id_map const * const ips,
                        wQueue * const q,
                        int fd_logfile);

#endif
