#ifndef WPUSH_H_INCLUDED
#define WPUSH_H_INCLUDED

#include <zmq.h>
#include <czmq.h>

#include "../common/queue.h"

zsock_t *init_wpush(const int proxy_number);

/* sends a TRANSFER-DONE message with provided header, worker ID and queuesize
 * via the push-zocket */
void signal_transfer_done(zsock_t * const push,
                          const int ack_header,
                          const int id,
                          wQueue const * const q,
                          const uint64_t timestamp);

#endif
