% heuristic_grouping.pl

benchmark_group(invariant,'scheduler_err.mch','SchedulerErr').
benchmark_group(invariant,'Simpson_Four_Slot_CSP.mch','Simpson4Slot').
benchmark_group(invariant,'Peterson_err.mch','Peterson_err').
benchmark_group(invariant,'CarlaTravelAgencyErr.mch','TravelAgency').
benchmark_group(invariant,'M21_err3_mch.eventb','SecureBldg_M21_err3').
benchmark_group(invariant,'m2_err.ref','Abrial_Press_m2_err').
benchmark_group(invariant,'m_partner_behaviour.eventb','SAP_M_Partner').
benchmark_group(invariant,'pkeyprot.mch','Needham-Schroeder').
benchmark_group(invariant,'dfcheck_houseset_simpler.mch','HousesetSimpler').
%benchmark_group(invariant,'dfcheck_houseset.mch','HousesetComplex').
benchmark_group(invariant,'NastyCoin.mch','NastyCoin').
benchmark_group(invariant,'BreadthFirstTest.mch','BFTest').
benchmark_group(invariant,'DepthFirstTest.mch','DFTest1').
benchmark_group(invariant,'DepthFirstTest2.mch','DFTest2').



benchmark_group(deadlock,'earley_3_v3.mch','Abrial_Earley3_v3').
benchmark_group(deadlock,'earley_3_v5.mch','Abrial_Earley3_v5').
benchmark_group(deadlock,'earley_4_v3.mch','Abrial_Earley4_v3').
benchmark_group(deadlock,'axl3_deadlock.mch','Alstom_axl3').
benchmark_group(deadlock,'exemple7.mch','Alstom_ex7').
benchmark_group(deadlock,'CrsCtl_m2.eventb','Bosch_CrsCtl').
benchmark_group(deadlock,'mchoreography.eventb','SAP_MChoreography').
benchmark_group(deadlock,'Dining_With_Protocol_in_B.mch','DiningPhil').
benchmark_group(deadlock,'cxcc0.eventb','CXCC0').

benchmark_group(goal,'RussianPostalPuzzle.mch','RussianPostal').
benchmark_group(goal,'TrainTorchPuzzle.mch','TrainTorch').
benchmark_group(goal,'BlocksWorldGeneric.mch','BlocksWorld').
benchmark_group(goal,'Farmer.mch','Farmer').
benchmark_group(goal,'Hanoi.mch','Hanoi').
benchmark_group(goal,'Puzzle8_difficult.mch','Puzzle8').
benchmark_group(goal,'RushHour.mch','RushHour').
benchmark_group(goal,'m13.ref','Abrial_Press_m13').
benchmark_group(goal,'m1.ref','Abrial_Queue_m1').
benchmark_group(goal,'Router.mch','SystemOnChip_Router').
benchmark_group(goal,'Wegenetz.mch','Wegenetz').

benchmark_group(noerror,'scheduler1.ref','Scheduler1').
benchmark_group(noerror,'Cruise_finite1.mch','Volvo_Cruise').
benchmark_group(noerror,'USB_4Endpoints.mch','USB4').
benchmark_group(noerror,'nota.mch','Nokia_Nota').
benchmark_group(noerror,'HuffmanM_mch.eventb','Huffman').
benchmark_group(noerror,'cont3.ref','Cansell_Contention').
benchmark_group(noerror,'ModeleGS_R1.ref','Demoney_GS_R1').
%benchmark_group(goal,'m13.ref','Abrial_Press_m13').
benchmark_group(noerror,'Router1.mch','SystemOnChip_Router').
benchmark_group(noerror,'mondex_m2.eventb','Mondex_m2').
benchmark_group(noerror,'mondex_m3.eventb','Mondex_m3').
benchmark_group(noerror,'siemens_mch_0.eventb','Siemens_ATP0').
benchmark_group(noerror,'obsw_M001.eventb','SSF_obsw1').
benchmark_group(noerror,'elevator12.eventb','ETH_Elevator12').
benchmark_group(noerror,'EchoAlg.mch','Echo').
