/*
 special_binary_predicate(equal(b(E1,T1,_),b(E2,T2,_)),KernelCall,Arg1,irrelevant,Arg2,irrelevant) :-
                 %print(try_special_equal(E1,T1,E2,T2)),nl,
                 special_equality_predicate(E1,T1,E2,T2,KernelCall,Arg1,Arg2).

% TO DO: the same for not_equal
% TO DO: detect disjoint
special_equality_predicate(integer(Number),integer, card(SETEXT),integer, kernel_objects:PRED,ARG1,ARG2) :-
        special_equality_predicate_aux(Number,SETEXT,PRED,ARG1,ARG2).
special_equality_predicate(card(SETEXT),integer, integer(Number),integer, kernel_objects:PRED,ARG1,ARG2) :-
        special_equality_predicate_aux(Number,SETEXT,PRED,ARG1,ARG2).

special_equality_predicate_aux(Number,SETEXT,all_different, list_of_expressions, LIST ) :-
                           % list_of_expressions: indicates Arg2 is list of expressions
                     SETEXT = b(set_extension(LIST),set(_Type),_Info),
                     ground(Number), %print(try_all_diff1(LIST,Number,_Type)),nl,
                     is_length(LIST,Number). %PRED = cardinality_of_set_extension_list
is_length(X,_) :- var(X),!,fail.
is_length([],0).
is_length([_|T],L) :- is_length(T,L1), L is L1+1.
*/

% TO DO: infer that Number <= length of LIST, even if Number not known
% maybe use a cart_of_set_extension expression procedure
/*
try_special_equal(card(
 b(range(b(comprehension_set([b(identifier(i),integer,_),b(identifier(_lambda_result_3),integer,[lambda_result])],
 b(conjunct(b(member(b(identifier(i),integer,_),
           b(interval(b(integer(1),integer,_),b(identifier(n),integer,_)),set(integer),_)),pred,_),
 b(equal(b(identifier(_lambda_result_3),integer,[lambda_result]),
    b(add(b(function(b(identifier(queens),set(couple(integer,integer)),_),
    b(identifier(i),integer,_)),integer,_),b(identifier(i),integer,_)),integer,_)),
 pred,[])),pred,[])),set(couple(integer,integer)),_)),set(integer),_)
 ),integer,
  identifier(n),integer)
 --> translate to cardinality_of_range() or cardinality_of_set_extension?
*/
:- if(environ(partially_evaluate, true)).
/* partial evaluation enabled */
:- use_module(partial_evaluator(pe)).
:- unfold(kernel_call_predicate(_Call,_Module,_WF,_Expr)).
:- execute(get_wait_flag0(_,_)).
:- execute(symbolic_closure_binary_operator(X),ground(X)).
:- execute(cst_not_in_boolean_type(X,_),ground(X)).
:- execute(binary_not_in_boolean_type(BOP,_),ground(BOP)).
:- unfold(binary_arg1_determines_value(_,_,_)).
:- execute(binary_function(X,M,P),(nonvar(X);ground(M:P))).
:- unfold(binary_kernel_call(_Module,_KernelFunction,_SV1,_SV2,_Value,_WF,_Expression,_Type,_Info)).
:- unfold(unary_kernel_call(_Module,_KernelFunction,_ESV1,_Value,_WF,_Expr,_T,_Span)).
:- execute(determined_binary_integer_function(_)).
:- execute(negate_binary_boolean_operator(A,_),nonvar(A)).
:- unfold(call_determined_integer_function(_KernelFunction,_ESV1,_ESV2,_Value,_WF0,_WF,_Span)).
%:- unfold(call_determined_integer_function2(KF,V1,V2,Val,WF0,Determined,WF,Span)).
:- execute(determined(X,Y,V,_Det,_),
           ( ground(X),(ground(Y) ; ground(V))  ;  ground(Y),ground(V) ) ). % TO DO: do this automatically based on block decls
:- execute( call_determined_integer_function2(_KernelFunction,_ESV1,_ESV2,_Value,_WF0,Det,_WF,_Span),
   (Det==determined)). % then it is determined
:- unfold(binary_in_kernel_call(_Module,_Kernel_predicate,_ElValue,_SV1,_SV2,_WF,_Expr)).
:- unfold(kernel_call(_Call,_HasToBeGround,_WF,_Expr)).
:- execute(expects_waitflag_and_span(X),nonvar(X)).
:- execute(expects_waitflag(X),nonvar(X)).
:- execute(reversible_unary_function(X),nonvar(X)).
:- unfold(special_propagate_binary_function(F,_A,_B,_Res,_),nonvar(F)).
:- unfold(must_succ_kernel_call(_Call,_HasToBeGround,_WF,_Expr)).
:- unfold(is_definitely_empty(A,_B,_C),nonvar(A)).
:- unfold(do_not_keep_symbolic(A,_B,_C,_R,_WF),nonvar(A)).
:- unfold(kernel_call_predicate_check_element_of_wf(_A,_B,_WF)).
:- endif.
